Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function GetFileSize Lib "kernel32" (ByVal hFile As Long, lpFileSizeHigh As Long) As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function SetFilePointer Lib "kernel32" (ByVal hFile As Long, ByVal lDistanceToMove As Long, lpDistanceToMoveHigh As Long, ByVal dwMoveMethod As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function CreateFileW Lib "kernel32" (ByVal lpFileName As Long, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Private Declare Function FlushFileBuffers Lib "kernel32" (ByVal hFile As Long) As Long
Private Declare Function DeleteFileW Lib "kernel32.dll" (ByVal lpFileName As String) As Long
Private Declare Function GetTempPathW Lib "kernel32.dll" (ByVal nBufferLength As Long, ByRef lpBuffer As Long) As Long
Private Declare Function MessageBoxW Lib "user32.dll" (ByVal hwnd As Long, ByRef lpText As Long, ByRef lpCaption As Long, ByVal wType As Long) As Long
Private Declare Function WideCharToMultiByte Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpDefaultChar As String, ByVal lpUsedDefaultChar As Long) As Long
Private Declare Function MultiByteToWideChar Lib "kernel32" (ByVal CodePage As Long, ByVal dwFlags As Long, ByRef lpMultiByteStr As Any, ByVal cchMultiByte As Long, ByVal lpWideCharStr As Long, ByVal cchWideChar As Long) As Long


Private Const CP_UTF8  As Long = 65001
Private Const MAX_PATH As Long = 260
Public Const GENERIC_WRITE As Long = &H40000000
Public Const GENERIC_READ As Long = &H80000000
Public Const FILE_ATTRIBUTE_NORMAL As Long = &H80&
Public Const CREATE_ALWAYS = 2
Public Const OPEN_ALWAYS = 4
Public Const INVALID_HANDLE_VALUE = -1
Public Const INVALID_SET_FILE_POINTER = -1
Public Const INVALID_FILE_SIZE = -1
Public Const FILE_BEGIN = 0, FILE_CURRENT = 1, FILE_END = 2

Public Function MessageBox(ByVal sText As String)
    MessageBoxW 0&, ByVal StrPtr(sText), ByVal StrPtr(App.Title), 0&
End Function

Public Function GetTempPath() As String
    Dim lRet  As Long, sBuff As String
    sBuff = String(MAX_PATH, vbNullChar)
    lRet = GetTempPathW(MAX_PATH, ByVal StrPtr(sBuff))
    If lRet Then
        GetTempPath = Left$(sBuff, lRet)
    End If
End Function

Public Function DeleteFile(sPath As String) As Boolean
    DeleteFile = DeleteFileW(StrPtr(sPath))
End Function


Public Function OpenFile(sPath As String, Optional AccessMode As Long = GENERIC_WRITE Or GENERIC_READ) As Long
    OpenFile = CreateFileW(StrPtr(sPath), AccessMode, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0)
End Function

Public Function FileRead(ByVal hFile As Long, Optional Offset As Long, Optional Buffer As Variant) As Long
    
    If Offset > 0 Then Call SetFilePointer(hFile, Offset - 1, ByVal 0&, FILE_BEGIN)
    
    Select Case VarType(Buffer)
        Case 8209
            Call ReadFile(hFile, Buffer(LBound(Buffer)), UBound(Buffer) - LBound(Buffer) + 1, FileRead, 0)
        Case 8
            Dim Data() As Byte
            ReDim Data(Len(Buffer) - 1)
            Call ReadFile(hFile, Data(0), Len(Buffer), FileRead, 0)
            Buffer = StrConv(Data, vbUnicode)
    End Select
End Function

Public Sub SeekFile(hFile As Long, ByVal Offset As Long)
    Call SetFilePointer(hFile, Offset - 1, ByVal 0&, FILE_BEGIN)
End Sub

Public Function IsEOF(hFile As Long) As Boolean
    Dim lRet As Long
    lRet = SetFilePointer(hFile, ByVal 0&, ByVal 0&, FILE_CURRENT)
    Debug.Print GetFileSize(hFile, 0), lRet
    IsEOF = GetFileSize(hFile, 0) = lRet
End Function


Public Function FileWrite(ByVal hFile As Long, Optional Offset As Long, Optional Buffer As Variant) As Long
    Dim Data() As Byte
    
    If Offset > 0 Then Call SetFilePointer(hFile, Offset - 1, ByVal 0&, FILE_BEGIN)
   
    Select Case VarType(Buffer)
        Case 8209   'byte array
            Call WriteFile(hFile, Buffer(LBound(Buffer)), UBound(Buffer) - LBound(Buffer) + 1, FileWrite, 0)
        Case 8      'String
            Data = StrConv(Buffer, vbFromUnicode)
            Call WriteFile(hFile, Data(0), Len(Buffer), FileWrite, 0)

        'Case Else 'long, integer   'no yets
        '    ReDim Data(Len(Buffer) - 1)
        '    CopyMemory Data(0), VarPtr(Buffer), Len(Buffer)
        '    Call WriteFile(hFile, Data(0), Len(Buffer), FileWrite, 0)

    End Select
End Function

Public Function LenOfFile(hFile As Long) As Long
     LenOfFile = GetFileSize(hFile, 0&)
End Function


Public Sub CloseFile(hFile As Long)
    CloseHandle hFile: hFile = 0
End Sub

Public Function UTF82Unicode(ByVal sUTF8 As String) As String

    Dim UTF8Size As Long
    Dim BufferSize As Long
    Dim BufferUNI As String
    Dim LenUNI As Long
    Dim bUTF8() As Byte
    
    If LenB(sUTF8) = 0 Then Exit Function
    
    bUTF8 = StrConv(sUTF8, vbFromUnicode)
    UTF8Size = UBound(bUTF8) + 1
    
    BufferSize = UTF8Size * 2
    BufferUNI = String$(BufferSize, vbNullChar)
    
    LenUNI = MultiByteToWideChar(CP_UTF8, 0, bUTF8(0), UTF8Size, StrPtr(BufferUNI), BufferSize)
    
    If LenUNI Then
        UTF82Unicode = Left$(BufferUNI, LenUNI)
    End If

End Function


Public Function Unicode2UTF8(ByVal strUnicode As String) As String

    Dim LenUNI As Long
    Dim BufferSize As Long
    Dim LenUTF8 As Long
    Dim bUTF8() As Byte
    
    LenUNI = Len(strUnicode)
    
    If LenUNI = 0 Then Exit Function
    
    BufferSize = LenUNI * 3 + 1
    ReDim bUTF8(BufferSize - 1)
    
    LenUTF8 = WideCharToMultiByte(CP_UTF8, 0, StrPtr(strUnicode), LenUNI, bUTF8(0), BufferSize, vbNullString, 0)
    
    If LenUTF8 Then
        ReDim Preserve bUTF8(LenUTF8 - 1)
        Unicode2UTF8 = StrConv(bUTF8, vbUnicode)
    End If

End Function
